## lomiri-api 0.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.10)

# Default install location. Must be set here, before setting the project.
if (NOT DEFINED CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX ${CMAKE_BINARY_DIR}/install CACHE PATH "" FORCE)
endif()

project(lomiri-api C CXX)

if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
   message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower) # Build types should always be lowercase but sometimes they are not.

include(PrecompiledHeaders)
find_package(CoverageReport)
#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage (or ninja if you use that backend)
#  * Find html report in subdir coveragereport
#  * Find xml report suitable for jenkins in coverage.xml
#####################################################################
if(cmake_build_type_lower MATCHES coverage)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage" )
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage" )
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage" )
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage" )

  # We add -g when building with coverage so valgrind reports line numbers.
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g" )
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g" )

  # This allows us to skip the file descriptor closing test in Daemon_test
  # when coverage is enabled. (Closing file descriptors
  # in the test messes with coverage reporting.)
  add_definitions(-DCOVERAGE_ENABLED)
endif()

# Make sure we have all the needed symbols
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,defs")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,defs")

# Static C++ checks

find_program(CPPCHECK_COMMAND NAMES cppcheck)
if (CPPCHECK_COMMAND)
    set(CPPCHECK_COMMAND_OPTIONS --check-config --inline-suppr --enable=all -q --error-exitcode=2)
    set(CPPCHECK_COMMAND_OPTIONS ${CPPCHECK_COMMAND_OPTIONS} --template "{file}({line}): {severity} ({id}): {message}")
    add_custom_target(cppcheck COMMAND ${CPPCHECK_COMMAND} ${CPPCHECK_COMMAND_OPTIONS}
        ${CMAKE_SOURCE_DIR}/src
        ${CMAKE_SOURCE_DIR}/test
        ${CMAKE_BINARY_DIR}/test
        VERBATIM
    )
else()
    message(WARNING "Cannot find cppcheck: cppcheck target will not be available")
endif()

#
# Definitions for testing with valgrind.
#

configure_file(CTestCustom.cmake.in CTestCustom.cmake) # Tests in CTestCustom.cmake are skipped for valgrind

find_program(MEMORYCHECK_COMMAND NAMES valgrind)
if (MEMORYCHECK_COMMAND)
    set(MEMORYCHECK_COMMAND_OPTIONS
        "--suppressions=${CMAKE_SOURCE_DIR}/valgrind-suppress --leak-check=full --num-callers=40 --error-exitcode=3"
    )
    add_custom_target(valgrind DEPENDS NightlyMemCheck)
else()
    message(WARNING "Cannot find valgrind: valgrind target will not be available")
endif()


include(FindPkgConfig)
pkg_check_modules(GLIB glib-2.0 REQUIRED)

# Standard install paths
include(GNUInstallDirs)

# Shell install paths
set(SHELL_PLUGINDIR ${CMAKE_INSTALL_LIBDIR}/lomiri/qml)

include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    )

# When building the library, we set the default symbol visibility
# to "hidden", so we don't export things by default.
# Exported functions and classes are prefixed by a LOMIRI_API macro,
# which explicitly exports a symbol if LOMIRI_DLL_EXPORTS is defined.
add_definitions(-DLOMIRI_DLL_EXPORTS)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -pedantic -Wall -Wextra")

# -fno-permissive causes warnings with clang, so we only enable it for gcc
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-permissive")

    if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.0.0")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsuggest-override" )
    endif()
endif()

if ("${CMAKE_BUILD_TYPE}" STREQUAL "release" OR "${CMAKE_BUILD_TYPE}" STREQUAL "relwithdebinfo")
    option(Werror "Treat warnings as errors" ON)
else()
    option(Werror "Treat warnings as errors" OFF)
endif()

if (Werror)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Werror")
endif()

# API version
set(LOMIRI_API_MAJOR 0)
set(LOMIRI_API_MINOR 1)
set(LOMIRI_API_MICRO 7)
set(LOMIRI_API_VERSION "${LOMIRI_API_MAJOR}.${LOMIRI_API_MINOR}.${LOMIRI_API_MICRO}")

# API library
set(LOMIRI_API_LIB lomiri-api)

# Static version for testing
set(LOMIRI_API_STATIC_LIB lomiri-api-static)

# Other libraries we depend on
set(OTHER_API_LIBS)

# All the libraries we need to link a normal executable that uses the Lomiri API
set(LIBS ${LOMIRI_API_LIB} ${OTHER_API_LIBS})

# All the libraries we need to link a gtest executable. (We link the tests against a static version
# so we can do whitebox testing on internal classes.
set(TESTLIBS ${LOMIRI_API_STATIC_LIB} ${OTHER_API_LIBS})

# Library install prefix
set(LIB_INSTALL_PREFIX lib/${CMAKE_LIBRARY_ARCHITECTURE})

# Tests
if (NOT NO_TESTS)
    include(CTest)
    enable_testing()
    add_subdirectory(test)
else()
    message(STATUS "Tests disabled")
endif()

# add subdirectories to build
add_subdirectory(include)
add_subdirectory(src)
add_subdirectory(data)

if (cmake_build_type_lower MATCHES coverage)
  ENABLE_COVERAGE_REPORT(TARGETS ${LOMIRI_API_LIB} FILTER /usr/include ${CMAKE_SOURCE_DIR}/test/* ${CMAKE_BINARY_DIR}/*)
endif()

#
# Documentation
#

find_package(Doxygen)
find_program(DOT_EXECUTABLE dot /usr/bin)
if (NOT DOXYGEN_FOUND OR NOT DOT_EXECUTABLE)
    message(WARNING "Cannot generate documentation: doxygen and/or graphviz not found")
else()
    configure_file(${PROJECT_SOURCE_DIR}/doc/Doxyfile.in ${PROJECT_BINARY_DIR}/doc/Doxyfile @ONLY IMMEDIATE)
    add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/doc/lib${LOMIRI_API_LIB}/index.html
                       COMMAND ${DOXYGEN_EXECUTABLE} ${PROJECT_BINARY_DIR}/doc/Doxyfile
                       DEPENDS ${PROJECT_BINARY_DIR}/doc/Doxyfile
                               ${LOMIRI_API_LIB_SRC}
                               ${LOMIRI_API_LIB_HDRS})
    add_custom_target(doc ALL
                       DEPENDS ${PROJECT_BINARY_DIR}/doc/lib${LOMIRI_API_LIB}/index.html)
    install(DIRECTORY ${PROJECT_BINARY_DIR}/doc/lib${LOMIRI_API_LIB}
            DESTINATION ${CMAKE_INSTALL_PREFIX}/share/doc)
endif()

=== src/CMakeLists.txt ===
add_subdirectory(lomiri)

include_directories(${GLIB_INCLUDE_DIRS})

# Pseudo-library of object files. We need a dynamic version of the library for normal clients,
# and a static version for the whitebox tests, so we can write unit tests for classes in the internal namespaces
# (because, for the .so, non-public APIs are compiled with -fvisibility=hidden).
# Everything is compiled with -fPIC, so the same object files are suitable for either library.
# Here, we create an object library that then is used to link the static and dynamic
# libraries, without having to compile each source file twice with different compile flags.

set(LOMIRI_API_LIB_OBJ ${LOMIRI_API_LIB}-obj)
add_library(${LOMIRI_API_LIB_OBJ} OBJECT ${LOMIRI_API_LIB_SRC})
set_target_properties(${LOMIRI_API_LIB_OBJ} PROPERTIES COMPILE_FLAGS "-fPIC")
add_pch(pch/lomiriapi_pch.hh ${LOMIRI_API_LIB_OBJ})

# Use the object files to make the shared library.
set(LOMIRI_API_SOVERSION 1)
add_library(${LOMIRI_API_LIB} SHARED $<TARGET_OBJECTS:${LOMIRI_API_LIB_OBJ}>)
set_target_properties(${LOMIRI_API_LIB} PROPERTIES
    VERSION "${LOMIRI_API_MAJOR}.${LOMIRI_API_MINOR}"
    SOVERSION ${LOMIRI_API_SOVERSION}
)
target_link_libraries(${LOMIRI_API_LIB} ${GLIB_LDFLAGS})

# Use the object files to make the static library. We add -fPIC to avoid compiling a second time.
add_library(${LOMIRI_API_STATIC_LIB} STATIC $<TARGET_OBJECTS:${LOMIRI_API_LIB_OBJ}>)
set_target_properties(${LOMIRI_API_STATIC_LIB} PROPERTIES OUTPUT_NAME ${LOMIRI_API_LIB})
target_link_libraries(${LOMIRI_API_STATIC_LIB} ${GLIB_LDFLAGS})

# Only the dynamic library gets installed.
install(TARGETS ${LOMIRI_API_LIB} LIBRARY DESTINATION ${LIB_INSTALL_PREFIX})

# Parent needs to know what all the source files are, for generating doc and the like.
set(LOMIRI_API_LIB_SRC ${LOMIRI_API_LIB_SRC} ${LOMIRI_SRC} PARENT_SCOPE)

=== src/lomiri/util/CMakeLists.txt ===
add_subdirectory(internal)

set(UTIL_SRC
    ${CMAKE_CURRENT_SOURCE_DIR}/Daemon.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/FileIO.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/IniParser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/SnapPath.cpp
)

set(LOMIRI_API_LIB_SRC ${LOMIRI_API_LIB_SRC} ${UTIL_SRC} PARENT_SCOPE)

=== include/lomiri/shell/application/CMakeLists.txt ===
set(INCLUDE_INSTALL_DIR include/lomiri/shell/application)

file(GLOB headers "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
file(GLOB internal_headers "${CMAKE_CURRENT_SOURCE_DIR}/internal/*.h")

install(FILES ${headers} DESTINATION ${INCLUDE_INSTALL_DIR})

set(LOMIRI_API_LIB_HDRS ${LOMIRI_API_LIB_HDRS} ${headers} ${internal_headers} PARENT_SCOPE)

set(VERSION 27)
set(PKGCONFIG_NAME "lomiri-shell-application")
set(PKGCONFIG_DESCRIPTION "Lomiri shell Application APIs")
set(PKGCONFIG_REQUIRES "Qt5Core")
set(PKGCONFIG_FILE lomiri-shell-application.pc)

configure_file(${CMAKE_SOURCE_DIR}/data/lomiri-shell-api.pc.in
  ${CMAKE_BINARY_DIR}/data/${PKGCONFIG_FILE} @ONLY
)

install(FILES ${CMAKE_BINARY_DIR}/data/${PKGCONFIG_FILE}
  DESTINATION ${LIB_INSTALL_PREFIX}/pkgconfig
)

=== debian/changelog ===
lomiri-api (0.1.0-5) unstable; urgency=medium

  * debian/liblomiri-api0.symbols:
    + Update for amd64 arm64 armel armhf i386 m68k mips64el mipsel powerpc
      ppc64 ppc64el s390x x32.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 19 Apr 2020 10:09:06 +0200

lomiri-api (0.1.0-4) unstable; urgency=medium

  * debian/patches:
    + Add 2001_disable-GioMemory_test.patch. Disable GioMemory_test as it fails
      on Debian's buildd infrastructure.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 18 Apr 2020 23:13:51 +0200

lomiri-api (0.1.0-3) unstable; urgency=medium

  * debian/control:
    + Add B-D: dbus-test-runner.
  * debian/rules:
    + Run unit tests in dbus-test-runner wrapped environment. Thanks to Lukas
      Weiss from postmarketOS for providing the hint. Let's hope unit tests
      now succeed.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 18 Apr 2020 21:48:16 +0200

lomiri-api (0.1.0-2) unstable; urgency=medium

  * debian/liblomiri-api0.symbols:
    + Update for m68k, ppc64, x32.

 -- Mike Gabriel <sunweaver@debian.org>  Thu, 16 Apr 2020 22:30:53 +0200

lomiri-api (0.1.0-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #952728).

  * debian/*:
    + Downgrade SOVERSION to 0 (in coordination with upstream).
  * debian/patches:
    + Add 0001_remove-smart-pointer-from-GRefString.patch. Fix FTBFS during
      unit tests in Debian bullseye and Ubuntu focal.
    + Add 0002_NEWS-Fix-project-name.patch.
  * debian/control:
    + Make Debian UBports Team maintainer; add myself to Uploaders: field.
    + Bump Standards-Version: to 4.5.0. No changes needed.
    + Add Vcs-*: fields.
    + Make SYNOPSES and LONG_DESCRIPTIONs more verbose.
    + Add Rules-Requires-Root: field and set it to 'no'.
    + Drop from B-D: g++:native (unversioned).
    + Drop from B-D: qt5-default (meta package).
    + Add B-Ds: symlinks, rdfind.
    + Add B-D pkg-kde-tools.
  * debian/{control,compat}:
    + Switch to debhelper-compat notation. Bump DH compat level to version 12.
  * debian/{control,copyright,watch}:
    + Switch upstream location to UBports' GitLab.
  * debian/copyright:
    + Add auto-generated copyright.in file.
    + Use secure Format: URL.
    + Add debian/* copyright info. Fix line length in short license text. Add
      Upstream-Contact: field.
    + Detailed file list copyright style.
  * debian/rules:
    + Move --fail-missing into dh_missing; Drop --parallel.
    + Add get-orig-source target.
    + Set hardening build flags.
    + Set QT_SELECT to 5.
    + Enable pkgkde_symbolshelper support in debhelper.
    + Use upstream's NEWS file as upstream ChangeLog.
  * debian/{rules,liblomiri-api-doc.install}:
    + Fix API doc installation location, symlink duplicate files.
  * debian/liblomiri-api0.symbols:
    + Ship symbols for amd64 builds (other archs still pending).
  * debian/liblomiri-api-doc.doc-base:
    + Add file.
  * debian/source/format:
    + Add file (3.0 (quilt)).
  * debian/source/lintian-overrides:
    + Override odd-historical-debian-changelog-version.
  * debian/upstream/metadata:
    + Add file, comply with DEP-12.

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 28 Feb 2020 16:19:25 +0100

unity-api (8.8+ubports) xenial; urgency=medium

  * Imported to UBports

 -- UBports auto importer <infra@ubports.com>  Tue, 20 Feb 2018 23:53:49 +0100

unity-api (8.7+17.04.20170404-0ubuntu1) zesty; urgency=medium

  [ Pete ]
  * Add Glib and GObject Assigner helpers.

  [ Pete Woods ]
  * unity::util - Add glib signal managers

  [ Rodney Dawes ]
  * Add utility function to prepend $SNAP to directory paths.

 -- Pete Woods <pete.woods@canonical.com>  Tue, 04 Apr 2017 09:37:43 +0000

unity-api (8.7) UNRELEASED; urgency=medium

  * Add popularity field to LauncherItem

 -- Michael Zanetti <michael.zanetti@canonical.com>  Tue, 04 Apr 2017 10:26:39 +0200

unity-api (8.6+17.04.20170317-0ubuntu1) zesty; urgency=medium

  [ Michael Zanetti ]
  * Add appId property to MirSurfaceInterface

  [ Pete Woods ]
  * unity::util - unique_gobject and share_gobject now throw for
    floating references (LP: #1672657)

 -- Lukáš Tinkl <lukas.tinkl@canonical.com>  Fri, 17 Mar 2017 11:08:20 +0000

unity-api (8.5) UNRELEASED; urgency=medium

  [ Michael Zanetti ]
  * Add RoleIsPrivate to launcher's quicklist entries

  [ Daniel d'Andrada ]
  * MirSurfaceInterface::allowClientResize

 -- Michael Zanetti <michael.zanetti@canonical.com>  Fri, 24 Feb 2017 13:57:12 +0000

unity-api (8.4+17.04.20170223-0ubuntu1) zesty; urgency=medium

  [ Pete Woods ]
  * unity::util - Make Glib and GObject memory management
    utilities handle NULL quietly.

 -- Pete Woods <pete.woods@canonical.com>  Thu, 23 Feb 2017 11:22:37 +0000

unity-api (8.3+17.04.20170217-0ubuntu1) zesty; urgency=medium

  [ Pete ]
  * unity::util - Add typedef macros to GlibMemory to make method
    and member variable definitions easier.

 -- Pete Woods <pete.woods@canonical.com>  Fri, 17 Feb 2017 14:12:04 +0000

unity-api (8.2+17.04.20170206-0ubuntu1) zesty; urgency=medium

  [ Daniel d'Andrada ]
  * MirSurfaceInterface: add childSurfaceList and parentSurface

 -- Albert Astals Cid <albert.astals@canonical.com>  Mon, 06 Feb 2017 09:11:03 +0000

unity-api (8.1+17.04.20170120.1-0ubuntu1) zesty; urgency=medium

  [ Pete ]
  * unity::util - add GObject shared memory utility classes
    and helper methods.
  * unity::util - add Glib memory management utility functions.

 -- Lukáš Tinkl <lukas.tinkl@canonical.com>  Fri, 20 Jan 2017 17:08:56 +0000

unity-api (8.1) UNRELEASED; urgency=medium

  * Added Mir::currentKeymap

 -- Lukáš Tinkl <lukas.tinkl@canonical.com>  Fri, 30 Sep 2016 13:20:00 +0200

unity-api (8.0+17.04.20170110.1-0ubuntu1) zesty; urgency=medium

  [ Albert Astals Cid ]
  * Enable -Wsuggest-override
  * Use the new Q_ENUM (Qt 5.5)

  [ Nick Dedekind ]
  * Fully qualify pointer type namespaces in signals so that the
    parameters can be used in qml.



=== debian/control ===
Source: lomiri-api
Priority: optional
Section: libs
Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: cmake,
               cmake-extras,
               dbus-test-runner,
               debhelper-compat (= 12),
               devscripts,
               lsb-release,
               doxygen,
               graphviz,
               libglib2.0-dev,
               libgtest-dev,
               google-mock,
               libqtdbustest1-dev,
               pkg-config,
               python3:any,
               qtbase5-dev (>= 5.5),
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qml-module-qtquick2,
               qml-module-qttest,
               symlinks,
               rdfind,
               pkg-kde-tools,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/core/lomiri-api/
Vcs-Git: https://salsa.debian.org/ubports/lomiri-api.git
Vcs-Browser: https://salsa.debian.org/ubports/lomiri-api/

Package: liblomiri-api0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends},
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: API for Lomiri shell integration (shared library)
 Lomiri Operating Environment is a convergent work shell designed
 for use cases on phone, tablet or desktop devices.
 .
 Lomiri API Library for integrating with the Lomiri shell.
 .
 This package contains the shared library.

Package: liblomiri-api-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblomiri-api0 (= ${binary:Version}),
         ${misc:Depends},
Description: API for Lomiri shell integration (development headers)
 Lomiri Operating Environment is a convergent work shell designed
 for use cases on phone, tablet or desktop devices.
 .
 Lomiri API Library for integrating with the Lomiri shell.
 .
 This package contains the development files.

Package: liblomiri-api-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: API for Lomiri shell integration (documentation)
 Lomiri Operating Environment is a convergent work shell designed
 for use cases on phone, tablet or desktop devices.
 .
 Lomiri API Library for integrating with the Lomiri shell.
 .
 This package contains the API documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DPKG_GENSYMBOLS_CHECK_LEVEL=4

export CC=$(DEB_HOST_GNU_TYPE)-gcc
export CXX=$(DEB_HOST_GNU_TYPE)-g++

# http://ccache.samba.org/manual.html#_precompiled_headers
export CCACHE_SLOPPINESS=time_macros

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export QT_SELECT := 5

%:
	dh $@ --with pkgkde_symbolshelper

override_dh_install:
	mkdir -p "$(CURDIR)/debian/tmp/usr/share/doc/liblomiri-api-doc/html/"
	mv $(CURDIR)/debian/tmp/usr/share/doc/liblomiri-api/* $(CURDIR)/debian/tmp/usr/share/doc/liblomiri-api-doc/html/
	find "$(CURDIR)/debian/tmp/usr/share/doc/liblomiri-api-doc/html/" -name *.md5 -delete; \
	rdfind -makesymlinks true "$(CURDIR)/debian/tmp/usr/share/doc/liblomiri-api-doc/html/"; \
	symlinks -rc "$(CURDIR)/debian/tmp/usr/share/doc/liblomiri-api-doc/html/"; \

	dh_install

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_test:
	mkdir -p $(CURDIR)/debian/test-home/.local/share
	export HOME=$(CURDIR)/debian/test-home \
	    && export XDG_DATA_HOME=$(CURDIR)/debian/test-home/.local/share \
	    && dbus-test-runner --keep-env --bus-type=both -m 300 -t dh_auto_test

override_dh_clean:
	rm -Rfv $(CURDIR)/debian/test-home/
	dh_clean

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

## lomiri-api 0.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,6 +6,7 @@
 endif()
 
 project(lomiri-api C CXX)
+set(PROJECT_VERSION "0.1.1")
 
 if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
    message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
@@ -125,7 +126,7 @@
 # API version
 set(LOMIRI_API_MAJOR 0)
 set(LOMIRI_API_MINOR 1)
-set(LOMIRI_API_MICRO 7)
+set(LOMIRI_API_MICRO 1)
 set(LOMIRI_API_VERSION "${LOMIRI_API_MAJOR}.${LOMIRI_API_MINOR}.${LOMIRI_API_MICRO}")
 
 # API library

=== include/lomiri/shell/application/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,9 @@
 
 file(GLOB headers "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
 file(GLOB internal_headers "${CMAKE_CURRENT_SOURCE_DIR}/internal/*.h")
+
+add_custom_target(appheaders
+                  SOURCES ${headers} ${internal_headers})
 
 install(FILES ${headers} DESTINATION ${INCLUDE_INSTALL_DIR})

=== src/lomiri/util/internal/CMakeLists.txt ===
set(UTIL_INTERNAL_SRC
    ${CMAKE_CURRENT_SOURCE_DIR}/DaemonImpl.cpp
)

set(LOMIRI_API_LIB_SRC ${LOMIRI_API_LIB_SRC} ${UTIL_INTERNAL_SRC} PARENT_SCOPE)

=== test/gtest/lomiri/util/CMakeLists.txt ===
add_subdirectory(Daemon)
add_subdirectory(DefinesPtrs)
add_subdirectory(FileIO)
add_subdirectory(GioMemory)
add_subdirectory(GlibMemory)
add_subdirectory(GObjectMemory)
add_subdirectory(IniParser)
add_subdirectory(ResourcePtr)
add_subdirectory(SnapPath)
add_subdirectory(Dbus)
add_subdirectory(internal)

=== debian/changelog ===
lomiri-api (0.1.1-4) unstable; urgency=medium

  * debian/liblomiri-api0.symbols:
    + Mark functions optional that are hidden with -O3 builds. (Closes:
      #980274).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 18 Jan 2021 17:02:23 +0100

lomiri-api (0.1.1-3) unstable; urgency=medium

  * debian/liblomiri-api0.symbols:
    + Update symbols using pkgkde-symbolshelper.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 27 Sep 2020 20:32:56 +0200

lomiri-api (0.1.1-2) unstable; urgency=medium

  * debian/patches:
    + Add 2002_no-whitespace-checks-in-debian-folder.patch.
      Ignore whitespace flaws in debian/ folder. This is not upstream's
      business.
  * debian/source/lintian-overrides:
    + Not required anymore.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 26 Sep 2020 21:21:42 +0200

lomiri-api (0.1.1-1) unstable; urgency=medium

  * New upstream release.
  * debian/patch:
    + Drop patches 0001, 0002 and 1001. All applied upstream.
  * debian/liblomiri-api0.symbols:
    + Update file for 0.1.1/amd64.
  * debian/control:
    + Bump DH compat level to version 13.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 26 Sep 2020 13:26:22 +0200

lomiri-api (0.1.0-7) unstable; urgency=medium

  * debian/control:
    + Fix Vcs-*: URLs.
  * debian/liblomiri-api0.symbols
    + Update symbols using pkgkde-symbolshelper.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 08 Sep 2020 14:44:38 +0200

lomiri-api (0.1.0-6) unstable; urgency=medium

  * debian/liblomiri-api0.symbols:
    + Update symbols for arm64, riscv64 and sh4.
  * debian/rules:
    + Include buildflags.mk.
    + Drop explicit DEB_LDFLAGS_MAINT_APPEND (--as-needed). Now the default.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 07 Sep 2020 21:28:19 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: cmake,
                cmake-extras,
                dbus-test-runner,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                devscripts,
                lsb-release,
                doxygen,
@@ -29,8 +29,8 @@
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/core/lomiri-api/
-Vcs-Git: https://salsa.debian.org/ubports/lomiri-api.git
-Vcs-Browser: https://salsa.debian.org/ubports/lomiri-api/
+Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-api.git
+Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-api/
 
 Package: liblomiri-api0
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -11,9 +11,9 @@
 # http://ccache.samba.org/manual.html#_precompiled_headers
 export CCACHE_SLOPPINESS=time_macros
 
+include /usr/share/dpkg/buildflags.mk
 # see FEATURE AREAS in dpkg-buildflags(1)
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 export QT_SELECT := 5

=== debian/watch ===
version=4
https://gitlab.com/ubports/core/lomiri-api/tags .*/lomiri-api-(\d\S+)\.tar\.gz

## lomiri-api 0.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 endif()
 
 project(lomiri-api C CXX)
-set(PROJECT_VERSION "0.1.1")
+set(PROJECT_VERSION "0.2.0")
 
 if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
    message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
@@ -125,8 +125,8 @@
 
 # API version
 set(LOMIRI_API_MAJOR 0)
-set(LOMIRI_API_MINOR 1)
-set(LOMIRI_API_MICRO 1)
+set(LOMIRI_API_MINOR 2)
+set(LOMIRI_API_MICRO 0)
 set(LOMIRI_API_VERSION "${LOMIRI_API_MAJOR}.${LOMIRI_API_MINOR}.${LOMIRI_API_MICRO}")
 
 # API library

=== test/headers/CMakeLists.txt ===
#
# Test that all header files compile stand-alone and that no public header includes an internal one.
#

set(root_inc_dir ${CMAKE_SOURCE_DIR}/include)

set(subdirs
    lomiri
    lomiri/api
    lomiri/util
)

set(exclusions
    "GioMemory.h"
    "GlibMemory.h"
    "GObjectMemory.h"
)

foreach(dir ${subdirs})

    string(REPLACE "/" "-" location ${dir})

    set(public_inc_dir ${root_inc_dir}/${dir})
    set(internal_inc_dir ${public_inc_dir}/internal)

    # Test that each public header compiles stand-alone.
    add_test(stand-alone-${location}-headers
        ${CMAKE_CURRENT_SOURCE_DIR}/compile_headers.py
            ${public_inc_dir} ${CMAKE_CXX_COMPILER} "-I${root_inc_dir} -I${public_inc_dir} ${CMAKE_CXX_FLAGS}" "--exclusions" ${exclusions})

    # Test that each internal header compiles stand-alone,
    # if internal headers exist.
    if(EXISTS ${internal_inc_dir})
      add_test(stand-alone-${location}-internal-headers
          ${CMAKE_CURRENT_SOURCE_DIR}/compile_headers.py
              ${internal_inc_dir} ${CMAKE_CXX_COMPILER} "-I${root_inc_dir} -I${internal_inc_dir} ${CMAKE_CXX_FLAGS}" "--exclusions" ${exclusions})
    endif(EXISTS ${internal_inc_dir})

    # Test that no public header includes an internal header
    add_test(clean-public-${location}-headers ${CMAKE_CURRENT_SOURCE_DIR}/check_public_headers.py ${public_inc_dir})

endforeach(dir)

add_test(cleanincludes ${CMAKE_CURRENT_SOURCE_DIR}/includechecker.py ${CMAKE_SOURCE_DIR}/include)

=== debian/changelog ===
lomiri-api (0.2.0-1) unstable; urgency=medium

  [ Mike Gabriel ]
  * New upstream release.
  * debian/control:
    + Bump Standards-Version: to 4.6.2. No changes needed.
  * debian/copyright:
    + Update Upstream-Contact: field (change mail address).
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/:
    + Update upstream Git repo URL.
  * debian/patches:
    + Drop 2002_no-whitespace-checks-in-debian-folder.patch. Adopted upstream.

  [ Anton Gladky ]
  * debian/.gitlab-ci.yml:
    + Add file.
    + Let blhc fail.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 30 Jan 2023 21:07:24 +0100

=== debian/control ===
--- 
+++ 
@@ -26,9 +26,9 @@
                symlinks,
                rdfind,
                pkg-kde-tools,
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
-Homepage: https://gitlab.com/ubports/core/lomiri-api/
+Homepage: https://gitlab.com/ubports/development/core/lomiri-api/
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-api.git
 Vcs-Browser: https://salsa.debian.org/ubports-team/lomiri-api/

## lomiri-api 0.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 endif()
 
 project(lomiri-api C CXX)
-set(PROJECT_VERSION "0.2.0")
+set(PROJECT_VERSION "0.2.1")
 
 if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
    message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")
@@ -102,7 +102,7 @@
 add_definitions(-DLOMIRI_DLL_EXPORTS)
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -pedantic -Wall -Wextra")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17 -pedantic -Wall -Wextra")
 
 # -fno-permissive causes warnings with clang, so we only enable it for gcc
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")

=== test/CMakeLists.txt ===
set(LOMIRI_API_TEST_DATADIR "${CMAKE_CURRENT_SOURCE_DIR}/data")

configure_file(lomiri-api-test-config.h.in lomiri-api-test-config.h @ONLY)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(gtest)
add_subdirectory(headers)
add_subdirectory(copyright)
add_subdirectory(whitespace)
add_subdirectory(qmltest)

=== test/qmltest/modules/TestUtil/CMakeLists.txt ===
find_package(Qt5Core REQUIRED)
find_package(Qt5Quick REQUIRED)

set(CMAKE_AUTOMOC ON)
add_definitions(-DQT_NO_KEYWORDS)

set(TestUtilQML_SOURCES
    TestUtil.cpp
    TestUtilPlugin.cpp
)

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
)

add_library(TestUtilQml MODULE ${TestUtilQML_SOURCES})

target_link_libraries(TestUtilQml Qt5::Core Qt5::Quick)

# copy qmldir file into build directory for shadow builds
file(GLOB QML_JS_FILES qmldir *.js *.qml)
add_custom_target(TestUtil-qmlfiles ALL
                    COMMAND cp ${QML_JS_FILES} ${CMAKE_CURRENT_BINARY_DIR}
                    DEPENDS ${QML_JS_FILES}
                    SOURCES ${QML_JS_FILES}
)

# tests
include(QmlTest)

add_qml_test(test TestUtil
    IMPORT_PATHS ${CMAKE_BINARY_DIR}/test/qmltest/modules
    PROPERTIES ENVIRONMENT "QT_QPA_PLATFORM=minimal"
)

=== debian/changelog ===
lomiri-api (0.2.1-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 02:31:49 +0000

lomiri-api (0.2.1-1build2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:08:19 +0000

lomiri-api (0.2.1-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:34:43 +0000

lomiri-api (0.2.1-1) unstable; urgency=medium

  * New upstream release v0.2.1
  * debian/patches: Add patch to fix FTBFS with gcc13 (fixes: #1037762)
  * debian/rules: Use default gensymbols check level
  * debian/symbols: Refresh symbols

 -- Marius Gripsgard <mariogrip@debian.org>  Thu, 27 Jul 2023 03:07:52 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: lomiri-api
 Priority: optional
 Section: libs
-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
 Build-Depends: cmake,

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/lomiri-api/tags .*/lomiri-api-(\d\S+)\.tar\.gz

## lomiri-api 0.2.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 endif()
 
 project(lomiri-api C CXX)
-set(PROJECT_VERSION "0.2.1")
+set(PROJECT_VERSION "0.2.2")
 
 if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
    message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")

=== test/whitespace/CMakeLists.txt ===
#
# Test that all source files, cmakefiles, etc. do not contain trailing whitespace.
#

add_test(whitespace ${CMAKE_CURRENT_SOURCE_DIR}/check_whitespace.py ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR} ${CMAKE_SOURCE_DIR}/debian/)

=== include/lomiri/shell/notifications/CMakeLists.txt ===
set(INCLUDE_INSTALL_DIR include/lomiri/shell/notifications)

file(GLOB headers "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
file(GLOB internal_headers "${CMAKE_CURRENT_SOURCE_DIR}/internal/*.h")

install(FILES ${headers} DESTINATION ${INCLUDE_INSTALL_DIR})

set(LOMIRI_API_LIB_HDRS ${LOMIRI_API_LIB_HDRS} ${headers} ${internal_headers} PARENT_SCOPE)

set(VERSION 3)
set(PKGCONFIG_NAME "lomiri-shell-notifications")
set(PKGCONFIG_DESCRIPTION "Lomiri shell Notifications APIs")
set(PKGCONFIG_REQUIRES "Qt5Core")
set(PKGCONFIG_FILE lomiri-shell-notifications.pc)

configure_file(${CMAKE_SOURCE_DIR}/data/lomiri-shell-api.pc.in
  ${CMAKE_BINARY_DIR}/data/${PKGCONFIG_FILE} @ONLY
)

install(FILES ${CMAKE_BINARY_DIR}/data/${PKGCONFIG_FILE}
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

=== test/gtest/lomiri/api/CMakeLists.txt ===
add_subdirectory(Version)

=== test/qmltest/mocks/plugins/Lomiri/Notifications/Mocks/CMakeLists.txt ===
set(MockNotificationsPlugin_SOURCES
    MockNotificationsPlugin.cpp
)

add_library(MockNotificationsPlugin MODULE ${MockNotificationsPlugin_SOURCES})

#find_package(Qt5Core REQUIRED)
#find_package(Qt5Quick REQUIRED)
target_link_libraries(MockNotificationsPlugin Qt5::Core Qt5::Quick)

target_link_libraries(MockNotificationsPlugin NotificationsMocks)

add_custom_target(MockNotificationsPluginQmldir ALL
    COMMAND cp "${CMAKE_CURRENT_SOURCE_DIR}/qmldir" "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS qmldir
)

=== debian/changelog ===
lomiri-api (0.2.2-1) unstable; urgency=medium

  [ Marius Gripsgard ]
  * debian/control:
    + Add myself (mariogrip) as uploader

  [ Mike Gabriel ]
  * New upstream release.
  * debian/patches:
    + Drop 0001-fix-gcc13.patch. Applied upstream.
  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.
  * debian/liblomiri-api0.symbols:
    + Drop file. Symbols for C++ code are discontinued for Lomiri packaging.
  * debian/copyright:
    + Update attributions for debian/.
  * debian/control:
    + In B-D: , switch from pkg-config to pkgconf.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 06 Jan 2025 16:29:40 +0100

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: lomiri-api
 Priority: optional
 Section: libs
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
+ Marius Gripsgard <mariogrip@debian.org>,
 Build-Depends: cmake,
                cmake-extras,
                dbus-test-runner,
@@ -17,7 +17,7 @@
                libgtest-dev,
                google-mock,
                libqtdbustest1-dev,
-               pkg-config,
+               pkgconf,
                python3:any,
                qtbase5-dev (>= 5.5),
                qtdeclarative5-dev,

## lomiri-api 0.2.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 2.8.10)
+cmake_minimum_required(VERSION 3.10)
 
 # Default install location. Must be set here, before setting the project.
 if (NOT DEFINED CMAKE_INSTALL_PREFIX)
@@ -6,7 +6,7 @@
 endif()
 
 project(lomiri-api C CXX)
-set(PROJECT_VERSION "0.2.2")
+set(PROJECT_VERSION "0.2.3")
 
 if(${PROJECT_BINARY_DIR} STREQUAL ${PROJECT_SOURCE_DIR})
    message(FATAL_ERROR "In-tree build attempt detected, aborting. Set your build dir outside your source dir, delete CMakeCache.txt from source root and try again.")

=== data/CMakeLists.txt ===
# Set up package config.
set(PKGCONFIG_NAME "lomiri-shell-api")
set(PKGCONFIG_DESCRIPTION "Lomiri shell APIs")
set(PKGCONFIG_PLUGINDIR "${SHELL_PLUGINDIR}")
set(VERSION "1.0")

configure_file(lomiri-shell-api.pc.in lomiri-shell-api.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lomiri-shell-api.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

configure_file(lib${LOMIRI_API_LIB}.pc.in lib${LOMIRI_API_LIB}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/lib${LOMIRI_API_LIB}.pc DESTINATION ${LIB_INSTALL_PREFIX}/pkgconfig)

=== include/CMakeLists.txt ===
set(HDR_INSTALL_DIR include)
add_subdirectory(lomiri)

set(LOMIRI_API_LIB_HDRS ${LOMIRI_API_LIB_HDRS} PARENT_SCOPE)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 add_pch(pch/lomiriapi_pch.hh ${LOMIRI_API_LIB_OBJ})
 
 # Use the object files to make the shared library.
-set(LOMIRI_API_SOVERSION 1)
+set(LOMIRI_API_SOVERSION 0)
 add_library(${LOMIRI_API_LIB} SHARED $<TARGET_OBJECTS:${LOMIRI_API_LIB_OBJ}>)
 set_target_properties(${LOMIRI_API_LIB} PROPERTIES
     VERSION "${LOMIRI_API_MAJOR}.${LOMIRI_API_MINOR}"

=== include/lomiri/CMakeLists.txt ===
add_subdirectory(api)
add_subdirectory(shell)
add_subdirectory(util)

file(GLOB headers "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
file(GLOB internal_headers "${CMAKE_CURRENT_SOURCE_DIR}/internal/*.h")

install(FILES ${headers} DESTINATION ${HDR_INSTALL_DIR}/lomiri)

set(LOMIRI_API_LIB_HDRS ${LOMIRI_API_LIB_HDRS} ${headers} ${internal_headers} PARENT_SCOPE)

=== src/lomiri/CMakeLists.txt ===
add_subdirectory(api)
add_subdirectory(internal)
add_subdirectory(util)

set(LOMIRI_SRC
    ${CMAKE_CURRENT_SOURCE_DIR}/Exception.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/LomiriExceptions.cpp
)

set(LOMIRI_API_LIB_SRC ${LOMIRI_API_LIB_SRC} ${LOMIRI_SRC} PARENT_SCOPE)

=== test/copyright/CMakeLists.txt ===
#
# Test that all source files contain a copyright header.
#

add_test(copyright ${CMAKE_CURRENT_SOURCE_DIR}/check_copyright.sh
    ${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})

=== test/gtest/CMakeLists.txt ===
find_package(Threads REQUIRED)
find_package(GMock REQUIRED)
set(TESTLIBS ${TESTLIBS} ${GTEST_BOTH_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})

# gtest does weird things with its own implementation of tr1::tuple. For clang, we need to
# set this macro, otherwise anything that includes gtest.h won't compile.
if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DGTEST_USE_OWN_TR1_TUPLE=1")
endif()

add_subdirectory(lomiri)

set(TEST_SRC
)

foreach(src ${TEST_SRC})
    get_filename_component(name ${src} NAME_WE)
    add_executable(${name} ${src})
    target_link_libraries(${name} ${TESTLIBS})
    string(REPLACE "_test" "" test_name ${name})
    add_test(${test_name} ${name})
endforeach(src)

=== test/qmltest/CMakeLists.txt ===
add_subdirectory(modules)
add_subdirectory(mocks)
add_subdirectory(lomiri)

=== include/lomiri/api/CMakeLists.txt ===
file(GLOB headers "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
file(GLOB internal_headers "${CMAKE_CURRENT_SOURCE_DIR}/internal/*.h")

#
# Generated headers
#
configure_file(Version.h.in Version.h)
set(headers ${headers} ${CMAKE_CURRENT_BINARY_DIR}/Version.h)

install(FILES ${headers} DESTINATION ${HDR_INSTALL_DIR}/lomiri/api)

set(LOMIRI_API_LIB_HDRS ${LOMIRI_API_LIB_HDRS} ${headers} ${internal_headers} PARENT_SCOPE)

=== include/lomiri/shell/CMakeLists.txt ===
add_subdirectory(notifications)
add_subdirectory(launcher)
add_subdirectory(application)

file(GLOB headers "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
file(GLOB internal_headers "${CMAKE_CURRENT_SOURCE_DIR}/internal/*.h")

install(FILES ${headers} DESTINATION ${HDR_INSTALL_DIR}/lomiri/shell)

set(LOMIRI_API_LIB_HDRS ${LOMIRI_API_LIB_HDRS} ${headers} ${internal_headers} PARENT_SCOPE)

=== include/lomiri/util/CMakeLists.txt ===
file(GLOB headers "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
file(GLOB internal_headers "${CMAKE_CURRENT_SOURCE_DIR}/internal/*.h")

install(FILES ${headers} DESTINATION ${HDR_INSTALL_DIR}/lomiri/util)

set(LOMIRI_API_LIB_HDRS ${LOMIRI_API_LIB_HDRS} ${headers} ${internal_headers} PARENT_SCOPE)

=== debian/changelog ===
lomiri-api (0.2.3-1) unstable; urgency=medium

  * New upstream release.
    - Support building with CMake 4. (Closes: #1113240).
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 01 Oct 2025 16:39:44 +0200

=== debian/control ===
--- 
+++ 
@@ -27,7 +27,7 @@
                symlinks,
                rdfind,
                pkg-kde-tools,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/lomiri-api/
 Vcs-Git: https://salsa.debian.org/ubports-team/lomiri-api.git

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
-export DPKG_GENSYMBOLS_CHECK_LEVEL=4
+#export DPKG_GENSYMBOLS_CHECK_LEVEL=4
 
 export CC=$(DEB_HOST_GNU_TYPE)-gcc
 export CXX=$(DEB_HOST_GNU_TYPE)-g++
